# Script by Ivica Ico Bukvic (SlipStreamScapes)
# http://meowing.ccm.uc.edu/~ico/
# Distributed under the GPL license
# Version 1.0 (July 2004)

import karamba
import os

# width of the desktop, width of the opened bar, bar height, and padding of the retracted menu
desktop = 1280
width = 144
padding = 36
height = 32

# do we want the 3ddesktop or the KDE desktop switching?
use3d = 1

#what is the maximum number of desktops
maxDesktops = 16

vector = 0
retracted = 0
current = 0
numDesktops = 0
head = None
middle = None

fx = []
desk = []
name = []

this = "desks"

def writeConfigEntryNow(widget, string, replace):
	filename = os.path.expanduser("~") + "/.superkaramba/" + this + ".rc"
	file = open( filename, "r")
	output = file.read()
	file.close()
	output = output.splitlines()
	
	i = 0
	desktop = ""
	for i in output:
		param = i.split()
		if param and param[0].find(string) != -1:
			desktop = desktop + string + "=" + replace + "\n"
		else:
			desktop = desktop + i +"\n"
	
	file = open( filename, "w")
	file.write(desktop)
	file.close

def prettyText(widget, size, font, r, g, b, textname):
    karamba.changeTextSize(widget, textname, size)
    karamba.changeTextFont(widget, textname, font)
    karamba.changeTextColor(widget, textname, r, g, b)

def highlightIcon(widget, num, audio):
	global desk
	global fx
	global current
	global retracted
	
	if ( current != num ) and ( fx[num] == 0 ):
		if ( retracted == 1 ):
			karamba.toggleWidgetRedraw(widget, 1)
		karamba.changeImageIntensity(widget, desk[num], 0.1, 0)
		fx[num] = 1
		karamba.redrawWidget(widget)
		if ( retracted == 1 ):
			karamba.toggleWidgetRedraw(widget, 0)
		#if ( audio == 1 ):
		#	os.popen("artsplay $HOME/Karamba/Borealis/sounds/onButton.wav&")

def restoreIcon(widget, num):
	global desk
	global fx
	global current
	
	if ( current != num ):
		if ( retracted == 1 ):
			karamba.toggleWidgetRedraw(widget, 1)
		karamba.removeImageEffects(widget, desk[num])
		fx[num] = 0
		karamba.redrawWidget(widget)
		if ( retracted == 1 ):
			karamba.toggleWidgetRedraw(widget, 0)
	
def gotoDesktop(widget, num):
	global current
	global numDesktops
	global retracted
	
	if ( current != num ):
		if ( retracted == 1 ) and ( startup != 1 ):
			karamba.toggleWidgetRedraw(widget, 1)
			resizeAll(widget, 1)
		for i in range( 1, numDesktops + 1 ):
			karamba.changeTextColor (widget, name[i], 0, 0, 0)
		karamba.changeTextColor (widget, name[num], 255, 255, 255)
		current = num

###############################################################################
## Function:    
##   detectResolution ( )
## 
## 
## Description: 
##   Runs xwininfo and sets the current XFree86 resolution to the golbal
##   variables resolutionX and resolutionY
## 
##  Thanks to Adam Geitgey for this code!
###############################################################################
def detectResolution():
	global desktop
	
	havexwininfo = os.system("which xwininfo >/dev/null")
	if (havexwininfo == 0):
		pass
	
	fp = os.popen("xwininfo -root -stats")
	output = fp.read()
	output = output.splitlines()
	
	i = 0
	for i in output:
		param = i.split()
		if (len(param) > 1):
			if param[0].find("Width:") != -1:
				desktop = int(param[1])

def detectCurrentDesktop():
	fp = os.popen("dcop kwin KWinInterface currentDesktop")
	output = fp.read()
	return int(output)

##########################################################
# Superkaramba API functions                             #
##########################################################
#this is called when you widget is initialized
def initWidget(widget):
	global desk
	global name
	global retracted
	global current
	global width
	global numDesktops
	global maxDesktops
	global vector
	global middle
	global head
	global countdown
	global startup

	startup = 1
	detectResolution()

	retracted = karamba.readConfigEntry (widget, "retracted")
	x = karamba.readConfigEntry (widget, "widgetPosX")
	y = karamba.readConfigEntry (widget, "widgetPosY")
	
	numDesktops = karamba.readConfigEntry (widget, "numDesktops")
	tmp = karamba.getNumberOfDesktops(widget)
	if ( tmp != numDesktops ):
		numDesktops = tmp
		writeConfigEntryNow(widget, "numDesktops", str(numDesktops))
		
	head = karamba.createImage (widget, 0, 0, "img/left.png")
	middle = karamba.createImage (widget, 16, 0, "img/middle.png")

	desk.append(karamba.createImage(widget, 5, 0, "img/desktop_22x22_bw.png"))
	name.append(karamba.createText(widget,18, 11, 10, 10, "?"))
	prettyText(widget, 8, "nimbus sans l", 255, 255, 255, name[0])

	x = 36
	for i in range( 1, maxDesktops + 1 ):
		desk.append(karamba.createImage(widget, x, 5, "img/desktop_22x22.png"))
		if ( i < 10 ):
			name.append(karamba.createText(widget,x+8, 11, 10, 10, str(i)))
		else:
			name.append(karamba.createText(widget,x+5, 11, 10, 10, str(i)))
		prettyText(widget, 8, "nimbus sans l", 0, 0, 0, name[i])
		x = x + 24
		if ( i > numDesktops ):
			karamba.hideImage( widget, desk[i] )
			karamba.hideText( widget, name[i] )

	if ( numDesktops < 4 ):
		tmp = 4
	else:
		tmp = numDesktops
		width = padding + (24 * tmp ) + 12
	karamba.resizeWidget(widget, width, height)
	karamba.resizeImage (widget, middle, tmp * 24 + 32, 32)
	
	for i in range( 0, maxDesktops + 1 ):
		fx.append( 0 )

	tmp = detectCurrentDesktop()
	highlightIcon(widget, tmp, 0)
	gotoDesktop(widget, tmp)

	if ( desktop - x != width ):
		karamba.moveWidget(widget, desktop - width, y)
		writeConfigEntryNow(widget, "widgetWidth", str(width))
		writeConfigEntryNow(widget, "widgetPosX", str(desktop - width))
	if ( retracted == 1 ):
		karamba.translateAll(widget,width - padding,0)
		karamba.redrawWidget(widget)
		karamba.toggleWidgetRedraw(widget, 0)
	
	vector = 0
	
	if ( use3d == 1 ):
		countdown = 1
	else:
		countdown = -1
		
	startup = 0

def widgetUpdated(widget):
	global numDesktops
	global vector
	global countdown
	
	if ( countdown > 0 ):
		countdown = countdown - 1
	elif ( countdown == 0 ):
		os.popen("3ddesktop &")
		countdown = -1
	
	tmp = karamba.getNumberOfDesktops(widget)
	if ( tmp != numDesktops ):
		writeConfigEntryNow(widget, "numDesktops", str(tmp))
		if ( tmp > numDesktops ):
			vector = 1
		else:
			vector = -1
		resizeAll(widget, tmp)
		
def resizeAll (widget, tmp):
	global middle
	global numDesktops
	global vector
	global maxDesktops
	global width
	global retracted

	if ( retracted == 0 ):
		if ( vector == -1 ):
			if ( numDesktops > 4 ) or ( tmp > 4 ):
				os.popen("artsplay $HOME/Karamba/Borealis/sounds/slide_out_short.wav&")
		else:
			if ( tmp > 4 ):
				os.popen("artsplay $HOME/Karamba/Borealis/sounds/slide_in_short.wav&")
	else:
		os.popen("artsplay $HOME/Karamba/Borealis/sounds/slide_out_rev2.wav")
		karamba.toggleWidgetRedraw(widget, 1)
		for i in range( width - padding ):
			karamba.translateAll(widget,-1,0)
			karamba.redrawWidget( widget )
		retracted = 0

	tmpcols = tmp
	if ( tmpcols < 4 ):
		tmpcols = 4
	
	for i in range(1, maxDesktops + 1):
		if ( i > tmp ):
			karamba.hideImage( widget, desk[i] )
			karamba.hideText( widget, name[i] )
		else:
			karamba.showImage( widget, desk[i] )
			karamba.showText( widget, name[i] )

	newWidth = padding + (24 * tmpcols) + 12
	(x, y) = karamba.getWidgetPosition(widget)
	
	if ( abs(newWidth - width) <= 48 ):
		rate = 1
	elif ( abs(newWidth - width) <= 96 ):
		rate = 2
	else:
		rate = 4
	
	if ( vector == 1 ):
		if ( newWidth != width ):
			karamba.resizeWidget(widget, newWidth, height)
			karamba.resizeImage ( widget, middle, tmpcols * 24 + 32, 32 )
			for i in range( 0, ((newWidth - width)/rate) ):
				x = x - rate
				karamba.moveWidget (widget, x, y)
				karamba.redrawWidgetBackground(widget)
			width = newWidth
		else:
			width = newWidth
			karamba.redrawWidgetBackground(widget)

	if ( vector == -1 ):
		if ( newWidth != width ):
			for i in range( 0, ((width - newWidth)/rate) ):
				x = x + rate
				karamba.moveWidget (widget, x, y)
				karamba.redrawWidgetBackground(widget)
			width = newWidth
			karamba.resizeImage ( widget, middle, tmpcols * 24 + 32, 32 )
			karamba.resizeWidget(widget, width, height)
		else:
			width = newWidth
			karamba.redrawWidgetBackground(widget)

	numDesktops = tmp
	
	writeConfigEntryNow(widget, "widgetWidth", str(width))
	writeConfigEntryNow(widget, "widgetPosX", str(x))
	writeConfigEntryNow(widget, "widgetPosY", str(y))
	writeConfigEntryNow(widget, "retracted", str(retracted))

def desktopChanged(widget, num):
	global current
	
	if ( current != num ):
		highlightIcon(widget, num, 0)
		gotoDesktop(widget, num)
		widgetMouseMoved(widget,0, 0, 0)

def widgetMouseMoved(widget, x, y, button):
	global desk
	global fx
	global numDesktops
	global use3d
	global retracted
	global width
	global padding
	
	if (retracted == 1 ):
		offset = width - padding
	else:
		offset = 0
	if (use3d == 1) and (x >= offset + 10) and (x < offset + 30) and (y >= 8) and (y < 25):
		highlightIcon(widget, 0, 1)
	elif ( fx[0] == 1 ):
		restoreIcon(widget, 0)
				
	if (retracted == 0):
		xPos = 37
		for i in range (1, numDesktops + 1):
			if (x >= xPos) and (x < xPos+20) and (y >= 8) and (y < 25):
				highlightIcon(widget, i, 1)
			elif ( fx[i] == 1 ):
				restoreIcon(widget, i)
			xPos = xPos + 24

#This gets called everytime our widget is clicked.
#Notes:
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button clicked:
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
#                    4,5 = Scroll wheel up and down
def widgetClicked(widget, x, y, button):
	global desktop
	global padding
	global height
	global width
	global retracted
	global numDesktops
	global use3d
	global current

	if (retracted == 1 ):
		offset = width - padding
	else:
		offset = 0
	if (button == 2) and (use3d == 1) and (x >= offset + 10) and (x < offset + 30) and (y >= 8) and (y < 25):
		os.popen("artsplay $HOME/Karamba/Borealis/sounds/click3.wav")
		os.popen("/usr/bin/3ddesk --view=carousel")
	
	if (button == 1):
		if (retracted == 0):
			xPos = 37
			for i in range( 1, numDesktops + 1 ):
				if (x >= xPos) and (x < xPos+20) and (y >= 8) and (y < 25) and (current != i):
					#os.popen("artsplay $HOME/Karamba/Borealis/sounds/click3.wav&")
					if ( use3d == 1 ):
						os.popen("/usr/bin/3ddesk --gotocolumn=" + str(i))
					else:
						os.popen("dcop kwin KWinInterface setCurrentDesktop " + str(i))
					return 0
				xPos = xPos + 24

		if (retracted == 1) and (x >= width - padding) or (retracted == 0):
			if ( retracted == 1 ):
				retracted = 0
				karamba.toggleWidgetRedraw( widget, 1 )
				os.popen("artsplay $HOME/Karamba/Borealis/sounds/slide_out_rev2.wav")
				for i in range( width - padding ):
					karamba.translateAll(widget,-1,0)
					karamba.redrawWidget( widget )
				karamba.redrawWidgetBackground(widget)
			else:
				os.popen("artsplay $HOME/Karamba/Borealis/sounds/slide_in_rev2.wav")
				for i in range( width - padding ):
					karamba.translateAll(widget,1,0)
					karamba.redrawWidget( widget )
				retracted = 1
				karamba.toggleWidgetRedraw( widget, 0 )
			writeConfigEntryNow(widget, "widgetPosX", str(x))
			writeConfigEntryNow(widget, "widgetPosY", str(y))
			writeConfigEntryNow(widget, "retracted", str(retracted))
