# Script by Ivica Ico Bukvic (SlipStreamScapes)
# http://meowing.ccm.uc.edu/~ico/
# Distributed under the GPL license
# Version 1.0 (July 2004)

import karamba
import os

# width & height of each Icon.

wperIcon = 25

# width of the desktop, width of the opened bar, bar height, and padding of the retracted menu
desktop = 1280
width = 144
padding = 36

head = None
middle = None
myTray = None

menu = None
menuItems = []

width = 0
height = 32
cols = 4
vector = 0
retracted = -1
this = "systray"

def writeConfigEntryNow(widget, string, replace):
	filename = os.path.expanduser("~") + "/.superkaramba/" + this + ".rc"
	file = open( filename, "r")
	output = file.read()
	file.close()
	output = output.splitlines()
	
	i = 0
	desktop = ""
	for i in output:
		param = i.split()
		if param and param[0].find(string) != -1:
			desktop = desktop + string + "=" + replace + "\n"
		else:
			desktop = desktop + i +"\n"
	
	file = open( filename, "w")
	file.write(desktop)
	file.close

###############################################################################
## Function:    
##   detectResolution ( )
## 
## 
## Description: 
##   Runs xwininfo and sets the current XFree86 resolution to the golbal
##   variables resolutionX and resolutionY
## 
##  Thanks to Adam Geitgey for this code!
###############################################################################
def detectResolution():
	global desktop
	
	havexwininfo = os.system("which xwininfo >/dev/null")
	if (havexwininfo == 0):
		pass
	
	fp = os.popen("xwininfo -root -stats")
	output = fp.read()
	output = output.splitlines()
	
	i = 0
	for i in output:
		param = i.split()
		if (len(param) > 1):
			if param[0].find("Width:") != -1:
				desktop = int(param[1])

##########################################################
# Superkaramba API functions                             #
##########################################################
#this is called when your widget is initialized
def initWidget(widget):
	global myTray
	global head
	global middle
	global menu
	global menuItems
	global width
	global height
	global cols
	global desktop
	global padding
	global retracted
	
	detectResolution()

	retracted = karamba.readConfigEntry (widget, "retracted")
	x = karamba.readConfigEntry (widget, "widgetPosX")
	y = karamba.readConfigEntry (widget, "widgetPosY")
	cols = karamba.readConfigEntry (widget, "cols")
	
	myTray = karamba.createSystray(widget, padding, 2, wperIcon * cols, height - 2)
	
	width = padding + wperIcon * cols + 8

	position = 0

	head = karamba.createImage (widget, position, 0, "img/left.png")

	position = position + 16
	
	middle = karamba.createImage (widget, position, 0, "img/middle.png")
	karamba.resizeImage (widget, middle, cols * wperIcon + 28, 32)
	karamba.moveSystray (widget, padding, 2, cols * wperIcon, height - 2 )
	karamba.resizeWidget(widget, width, height)
	karamba.createImage (widget, 4, 1, "img/tray.png")

	if ( desktop - x != width ):
		karamba.moveWidget(widget, desktop - width, y)
		writeConfigEntryNow(widget, "widgetWidth", str(width))
		writeConfigEntryNow(widget, "widgetPosX", str(desktop - width))
	if ( retracted == 1 ):
		karamba.hideSystray(widget)
		karamba.translateAll(widget,width - padding,0)
		karamba.redrawWidget(widget)
		karamba.toggleWidgetRedraw(widget, 0)

	systrayUpdated(widget)
	width = padding + wperIcon * cols + 8
	karamba.redrawWidgetBackground(widget)

def systrayUpdated(widget):
	global cols
	global vector
	
	num = karamba.getCurrentWindowCount(widget)
	
	if ( num != cols ) or ( cols < 5 ):
		if  ( num > cols ) or ( cols < 5 ):
			vector = 1
		else:
			vector = -1
		resizeAll(widget, num)

#This gets called everytime our widget is clicked.
#Notes:
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button clicked:
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
#                    4,5 = Scroll wheel up and down
def widgetClicked(widget, x, y, button):
	global menu
	global desktop
	global padding
	global wperIcon
	global cols
	global height
	global retracted
	global width
	
	if (button == 1):
		if (retracted == 1) and (x >= width - padding) or (retracted == 0):
			if ( retracted == 1 ):
				retracted = 0
				karamba.toggleWidgetRedraw( widget, 1 )
				os.popen("artsplay $HOME/Karamba/Borealis/sounds/slide_out_rev2.wav")
				for i in range( width - padding ):
					karamba.translateAll(widget,-1,0)
					karamba.redrawWidget( widget )
				karamba.showSystray(widget)
				karamba.redrawWidgetBackground( widget )
			else:
				os.popen("artsplay $HOME/Karamba/Borealis/sounds/slide_in_rev2.wav")
				for i in range( width - padding ):
					karamba.translateAll(widget,1,0)
					karamba.redrawWidget( widget )
				retracted = 1
				karamba.hideSystray(widget)
				karamba.toggleWidgetRedraw( widget, 0 )
			writeConfigEntryNow(widget, "widgetPosX", str(x))
			writeConfigEntryNow(widget, "widgetPosY", str(y))
			writeConfigEntryNow(widget, "retracted", str(retracted))

def resizeAll (widget, tmp):
	global myTray
	global middle
	global cols
	global vector
	global width
	global retracted
	
	if ( retracted == 0 ):
		if ( vector == -1 ):
			if ( cols > 4 ) or ( tmp > 4 ):
				os.popen("artsplay $HOME/Karamba/Borealis/sounds/slide_out_short.wav&")
		elif ( tmp > 4 ):
				os.popen("artsplay $HOME/Karamba/Borealis/sounds/slide_in_short.wav&")
	else:
		karamba.toggleWidgetRedraw( widget, 1 )
		os.popen("artsplay $HOME/Karamba/Borealis/sounds/slide_out_rev2.wav")
		for i in range( width - padding ):
			karamba.translateAll(widget,-1,0)
			karamba.redrawWidget( widget )
		retracted = 0
		karamba.showSystray(widget)
	
	if ( tmp < 4 ):
		tmp = 4

	karamba.moveSystray ( widget, padding, 2, wperIcon * tmp, height - 2 )

	newWidth = padding + wperIcon * tmp + 8
	(x, y) = karamba.getWidgetPosition(widget)
	
	rate = abs(newWidth - width)/5
	
	if ( vector == 1 ):
		if ( newWidth != width ):
			karamba.resizeWidget(widget, newWidth, height)
			karamba.resizeImage ( widget, middle, tmp * wperIcon + 28, 32 )
			for i in range( 0, rate ):
				x = x - 5
				karamba.moveWidget (widget, x, y)
				karamba.redrawWidgetBackground(widget)
			width = newWidth
		else:
			width = newWidth
			karamba.redrawWidgetBackground(widget)

	if ( vector == -1 ):
		if ( newWidth != width ):
			for i in range( 0, rate ):
				x = x + 5
				karamba.moveWidget (widget, x, y)
			width = newWidth
			karamba.resizeWidget(widget, width, height)
			karamba.resizeImage ( widget, middle, tmp * wperIcon + 28, 32 )
			karamba.redrawWidgetBackground(widget)
		else:
			width = newWidth
			karamba.redrawWidgetBackground(widget)
		
	if ( tmp >= 4 ):
		cols = tmp
	else:
		cols = 4
	
	writeConfigEntryNow(widget, "widgetWidth", str(width))
	writeConfigEntryNow(widget, "widgetPosX", str(x))
	writeConfigEntryNow(widget, "widgetPosY", str(y))
	writeConfigEntryNow(widget, "retracted", str(retracted))
	writeConfigEntryNow (widget, "cols", str(cols))
