#!/bin/sh
# Installation script for the Borealis superkaramba theme ver.1.0
# Copyright 2004 - Ivica Ico Bukvic
# http://meowing.ccm.uc.edu/~ico/
# This install script is made available under GPL license
# For more info regarding this license, please see http://www.gnu.org/copyleft/gpl.html

name='Borealis superkaramba theme v.2.3'
title='by Ivica Ico Bukvic
ico@fuse.net
http://meowing.ccm.uc.edu/~ico/
'
directory="/home/$user/Karamba/Borealis"
config="/home/$USER/.kde/share/config"
homepage='http://meowing.ccm.uc.edu/~ico/'
kde_page='http://kde-look.org/content/show.php?content=13876'
nsteps='of 8:'

#==============================================================

echo "The $name $title"

# Check if we are in the proper directory
pwd=`pwd`
if [ "$pwd" != "$HOME/Karamba/Borealis" ]; then
  echo "This script needs to be run from the install folder. Exiting..."
  exit 1
fi

echo -e "Uninstalling $name...\n"

if [ -w $HOME/.kde/Autostart/Borealis.sh ]; then
	rm -f ${HOME}/.kde/Autostart/Borealis.sh
fi
rm -f ${HOME}/.superkaramba/cpu.rc
rm -f ${HOME}/.superkaramba/desks.rc
rm -f ${HOME}/.superkaramba/discs.rc
rm -f ${HOME}/.superkaramba/main.rc
rm -f ${HOME}/.superkaramba/memory.rc
rm -f ${HOME}/.superkaramba/network.rc
rm -f ${HOME}/.superkaramba/systray.rc
rm -f ${HOME}/.superkaramba/wireless.rc
rm -f ${HOME}/.superkaramba/xmms.rc

if [ -w ${HOME}/.3ddesktop/3ddesktop.conf.old ]; then
  mv -f ${HOME}/.3ddesktop/3ddesktop.conf.old ${HOME}/.3ddesktop/3ddesktop.conf
else
  rm -f ${HOME}/.3ddesktop/3ddesktop.conf
fi

mv -f ${HOME}/.kde/share/config/ksmserverrc.old ${HOME}/.kde/share/config/ksmserverrc

kde_script=`which startkde`
test=`grep "killall 3ddesk" $kde_script`
if [ -n "$test" ]; then
  cat $kde_script | sed -e 's/killall 3ddeskd//' > ${HOME}/startkde
  echo -e "\nIMPORTANT!\n\nYour $kde_script has been altered due to use of 3ddeskd. In order to revert it to old version you will need to do the following after running this uninstall script:\n\nIn your $HOME directory you will find the file 'startkde'. As superuser simply type the following:\n\n   mv -f ${HOME}/startkde $kde_script\n\n"
fi

rm -rf ${HOME}/Karamba/Borealis/

echo -e "\nUninstall complete!\n\nThank you very much for your interest in $name.\nYour comments and suggestions are highly appreciated!\n\nFor latest news and updates please visit\n$kde_page\n\nHave a nice day!\n"

exit 0
