#NetVU AnalogMachine component
import karamba
import math
import os
#target network device, adjust accordingly:
TGT = "eth0"
#update interval in seconds, found in .theme (if you change it there, bring it back here!!!)
INTRV = 5
DSneedle = "pics/DSneedle.png"
DNneedle = "pics/DNneedle.png"
USneedle = "pics/USneedle.png"
UNneedle = "pics/UNneedle.png"
tooltip = ""
token = [ ]
height = 276
width = 276
DSN = 0
DNN = 0
USN = 0
UNN = 0
Down = 0
ODown = 0
Up = 0
OUp = 0
DownSpeed = 0
UpSpeed = 0
DScaleFactor = 0
UScaleFactor = 0
DNNdeg = 0
UNNdeg = 0
DSNdeg = [-155,-130,-110,-85,-65,-40,-20]
USNdeg = [155,130,110,85,65,40,20]
init = 0
#this is called when you widget is initialized
def initWidget(widget):
	pass

#the update interval is specified in the .theme file
def widgetUpdated(widget):
	global TGT
	global DSN
	global DNN
	global USN
	global UNN
	global token
	global init
	global Up
	global OUp
	global UpSpeed
	global Down
	global ODown
	global DownSpeed
	global INTRV
	global DScaleFactor
	global UScaleFactor
	global DSNdeg
	global USNdeg
	global UNNdeg
	global DNNdeg
	if init == 0:
		DSN = karamba.createImage(widget,0,0,DSneedle)
		DNN = karamba.createImage(widget,0,0,DNneedle)
		USN = karamba.createImage(widget,0,0,USneedle)
		UNN = karamba.createImage(widget,0,0,UNneedle)
		init = 1
	else:
		fd = open("/proc/net/dev", "r")
		data = fd.read()
		fd.close()
		data = data.splitlines()
		for l in data[:]:
			l = l.strip()
			l = l.replace(":"," ")
			fields = l.split()
			if fields[0]==TGT:
				Down = int(fields[1])
				Up = int(fields[9])
		#Download Speed and Scale
		DownSpeed = float( ( Down - ODown ) / ( INTRV * 1024 ) )				#Kx1
		DScaleFactor = 0
		if DownSpeed > 15:
			DownSpeed = float(DownSpeed / 2 )						#Kx2
			DScaleFactor = 1
			if DownSpeed > 15:
				DownSpeed = float(DownSpeed / 5 )					#Kx10
				DScaleFactor = 2
				if DownSpeed > 15:
					DownSpeed = float(DownSpeed / 10 )				#Kx100
					DScaleFactor = 3
					if DownSpeed > 15:
						DownSpeed = float( ( DownSpeed / 1024 ) * 100)		#Mx1
						DScaleFactor = 4
						if DownSpeed > 15:
							DownSpeed = float(DownSpeed / 2 )		#Mx2
							DScaleFactor = 5
							if DownSpeed > 15:
								DownSpeed = float(DownSpeed / 5)	#Mx10
								DScaleFactor = 6
		#Upload Speed and Scale
		UpSpeed = float( ( Up - OUp ) / ( INTRV * 1024 ) )				#Kx1
		UScaleFactor = 0
		if UpSpeed > 15:
			UpSpeed = float(UpSpeed / 2 )						#Kx2
			UScaleFactor = 1
			if UpSpeed > 15:
				UpSpeed = float(UpSpeed / 5 )					#Kx10
				UScaleFactor = 2
				if UpSpeed > 15:
					UpSpeed = float(UpSpeed / 10 )				#Kx100
					UScaleFactor = 3
					if UpSpeed > 15:
						UpSpeed = float( ( UpSpeed / 1024 ) * 100)	#Mx1
						UScaleFactor = 4
						if UpSpeed > 15:
							UpSpeed = float(UpSpeed / 2 )		#Mx2
							UScaleFactor = 5
							if UpSpeed > 15:
								UpSpeed = float(UpSpeed / 5)	#Mx10
								UScaleFactor = 6
		
		DNNdeg = int( ( DownSpeed * 7.4667 ) - 120 )
		UNNdeg = int( ( UpSpeed * -7.4667) + 120 )
		ODown = int(Down)
		OUp = int(Up)
		#here comes the hardcore!!
		karamba.rotateImage(widget, DNN, int(DNNdeg))
		w = karamba.getImageWidth(widget,DNN)
    		h = karamba.getImageHeight(widget,DNN)
    		karamba.moveImage(widget, DNN, -((w-width)/2), -((h-height)/2))
		karamba.rotateImage(widget, UNN, int(UNNdeg))
		w = karamba.getImageWidth(widget,UNN)
    		h = karamba.getImageHeight(widget,UNN)
    		karamba.moveImage(widget, UNN, -((w-width)/2), -((h-height)/2))
		karamba.rotateImage(widget, DSN, int(DSNdeg[DScaleFactor]))
		w = karamba.getImageWidth(widget,DSN)
    		h = karamba.getImageHeight(widget,DSN)
    		karamba.moveImage(widget, DSN, -((w-width)/2), -((h-height)/2))
		karamba.rotateImage(widget, USN, int(USNdeg[UScaleFactor]))
		w = karamba.getImageWidth(widget,USN)
    		h = karamba.getImageHeight(widget,USN)
    		karamba.moveImage(widget, USN, -((w-width)/2), -((h-height)/2))

		karamba.redrawWidget(widget)
def widgetClicked(widget, x, y, button):
   pass
def widgetMouseMoved(widget, x, y, button):
    pass
def menuItemClicked(widget, menu, id):
    pass
def itemDropped(widget, dropText):
    pass
def startupAdded(widget, startup):
    pass
def startupRemoved(widget, startup):
    pass
def taskAdded(widget, task):
    pass
def taskRemoved(widget, task):
    pass
def activeTaskChanged(widget, task):
    pass

print "Loaded NetVU python extension!" 