######################################
## Vik Bar - SuperKaramba Theme
## Initially based on cleanbar
## Some modifications for WinBar
######################################
import karamba
import os, time, re, string


# Global Variables
maxTasks = 0 #Maximum nuber of Tasks the bar can show

## Default res
## You don't need to change it.  It should auto-detect.
resX = 800
#resY = 600

## Task display stuff
allTasks = []
taskCount = 0

# Time stuff
timeText = 0

# ShortcutStuff
shorcuts = 0

## Icon Theme paths
kdeIconPaths = []

# offsets for display
shortcutPosition = 105
rightWidth = 123
taskWidth = 117
taskStartPosition = shortcutPosition

## Autodetect Resolution
havexwi = os.system("which xwininfo")

if (havexwi == 0):
  pass
else:
  print "\nCan't find xwininfo in your path."

fp = os.popen("xwininfo -root -stats")
output = fp.read()
output = output.splitlines()
i = 0
for x in output:
  param = x.split()
  if (len(param) > 1):
    if param[0].find("Width:") != -1:
      resX = int(param[1])
#    if param[0].find("Height:") != -1:
#      resY = int(param[1])



#Initialize Widget
def initWidget(widget):
  global resX
  global maxTasks
  global timeText
  global shortcuts
  global shortcutPosition
  global rightWidth
  global taskWidth
  global taskStartPosition

  karamba.createImage(widget, 0, 0, "pics/bar.png")
  karamba.createImage(widget, resX - rightWidth, 0, "pics/right.png")
  karamba.createImage(widget, (resX - rightWidth) + 11, 7, "icons/volume.png")
  karamba.createClickArea(widget, (resX - rightWidth) + 11, 7, 16, 16, "aumix")
  timeText = karamba.createText(widget, resX - rightWidth + 32, 7, 140, 20, "time")
  karamba.changeTextColor(widget, timeText, 255,255,255)
  karamba.changeTextSize(widget, timeText, 10)

  #Setup Shortcuts
  shortcuts = drawShortcuts(widget)

  #Figure out how many task you can have visible
  taskStartPosition = (18*shortcuts)+shortcutPosition
  maxTasks = (resX - taskStartPosition - rightWidth)/taskWidth


def widgetUpdated(widget):
  global maxTasks
  global allTasks
  global taskCount
  global language

  timeEntry = time.strftime("%H:%M %m/%d",time.localtime())
  karamba.changeText(widget, timeText, timeEntry)

  #hideTasks(widget, allTasks)

  #get list of tasks
  taskList = karamba.getTaskList(widget)
  taskCount = len(taskList)

  #Check to see if we have more tasks than the max showable tasks
  if (taskCount > maxTasks):
    taskCount = maxTasks

  #Check to see if the screen needs to be updated by checking if the task has changed.
  #Maybe in the future SuperKaramba will have a taskChanged() event?????
  #The logic is:
  #if number of visible tasks <= maxTasks *and*
  #if the number of visible tasks != number of actual tasks
  #we update the taskbar.
  #else it should stay the same.
  if (len(allTasks) <= maxTasks):
    if (len(allTasks) != taskCount):
      allTasks=clearTasks(widget, allTasks)
      for i in range(taskCount):
        currentTask = karamba.getTaskInfo(widget, taskList[i])
        allTasks.append(createTask(widget,i ,currentTask[0], currentTask[2], currentTask[8]))

  karamba.redrawWidget(widget)


def widgetClicked(widget, x, y, button):
  global taskWidth
  global taskStartPosition
  global allTasks

  taskSelected = (x-taskStartPosition)/taskWidth
  if (taskSelected > len(allTasks)-1):
    karamba.toggleShowDesktop(widget)
  elif (taskSelected > -1):
    karamba.performTaskAction(widget, allTasks[taskSelected][3], 8)


def widgetMouseMoved(widget, x, y, button):
  karamba.redrawWidget(widget)

def getIcon(widget, icon):
  global kdeIconPaths

  if (not kdeIconPaths):
    ## make list of paths
    ## Find the KDE icon theme
    kdeIconTheme = getKDEConfigValue(os.getenv("HOME") + "/.kde/share/config/kdeglobals", "Icons", "Theme")
    if ( (kdeIconTheme == -1) or (kdeIconTheme == "") or (re.match("^\d+$", kdeIconTheme)) ):
      print "KDE has no icon theme configured.  Using default.kde"
      kdeIconTheme = "default.kde"
    print "Current KDE Icon Theme: " + kdeIconTheme

    ## Get the paths that KDE is using for icons
    fp = os.popen("kde-config --path icon")
    output = []
    if (fp):
      output = fp.read()
      ## Strip newlines
      output = output.replace('\n', '')
      output = output.split(":")


    ## KDEDIR should probably be removed from future kroller versions
    ## and rely solely on the kde-config command, since KDEDIR var
    ## is being depricated.
    kdedir = os.getenv("KDEDIR")
    if (not kdedir):
      fp = os.popen("kde-config --prefix")
      if (fp):
        tmp = fp.read()
        tmp = tmp.replace('\n', '')
        kdedir = tmp
        del tmp
    if (not kdedir):
      kdedir = "/opt/kde"
    print "Detected KDEDIR: " + str(kdedir)
    if (not os.path.exists(kdedir)):
      print "ERROR - Could not locate the KDE installation directory!"

    ## Now look in KDE's icon paths
    kdeIconPaths = []

    ## These few entries *should* find everyones icons
    for entry in output:
      kdeIconPaths.append(entry + kdeIconTheme)

    ## Make sure to check the kroller theme dir for icons
    kdeIconPaths.append(karamba.getThemePath(widget))
    kdeIconPaths.append(karamba.getThemePath(widget) + "/icons")

    ## These should have already been added from the kde-config command, but just in case
    kdeIconPaths.append(os.getenv("HOME") + "/.kde/share/icons/" + kdeIconTheme)
    kdeIconPaths.append(kdedir + "/share/icons/" + kdeIconTheme)

    ## As a fallback check the default.kde and hicolor dirs
    for entry in output:
      kdeIconPaths.append(entry + "default.kde")
    for entry in output:
      kdeIconPaths.append(entry + "hicolor")

    ## Add a few more search paths just for paranoia's sake
    kdeIconPaths.append("/usr/share/icons" + kdeIconTheme)
    kdeIconPaths.append("/usr/share/icons")
    kdeIconPaths.append(kdedir + "/share/icons/default.kde")
    kdeIconPaths.append(kdedir + "/share/icons/hicolor")


  ## Now we find the icon from the search path
  sizes=["16x16"]
  types=['apps','devices','filesystems','mimetypes']

  ## If an absolute path was defined use that
  if (os.path.exists(icon)):
    return(icon)

  ## Look for the icon in all of the search paths discovered above
  for path in kdeIconPaths:
    if (os.path.exists(path + "/" + icon + ".png")):
      return(path + "/" + icon + ".png")
    if (os.path.exists(path + "/" + icon)):
      return(path + "/" + icon)
    for size in sizes:
      for typelist in types:
        if (os.path.exists(path + "/" + size + "/" + typelist + "/" + icon + ".png")):
          return(path + "/" + size + "/" + typelist + "/" + icon + ".png")
        if (os.path.exists(path + "/" + size + "/" + typelist + "/" + icon)):
          return(path + "/" + size + "/" + typelist + "/" + icon)

  ## Return -1 if we couldn't find the icon
  #print "ERROR - Coundn't find an icon for \"" + icon + "\""
  return karamba.getThemePath(widget) + "/icons/unknown.png"

def getKDEConfigValue(filename, section, option):
  """Read a KDE config file and return the value for option under the specified section"""

  ## FIXME: Should this function be replaced with calls to
  ## pythons ConfigParser?

  ## Open the configuration file
  try:
    file = open(filename,"r")
  except IOError:
    print
    print "ERROR While opening the configuration file [" + filename + "]"
    print

  ## Read through each line of the file
  while 1:
    line = file.readline()                        ## Read a line from the file
    if len(line) == 0:                            ## Break this while loop if we're at the end of the file
      break

    line = re.sub("#.*$", "", line)               ## Remove comments
    line = re.sub("//.*$", "", line)              ## Remove comments
    line = line.strip()                           ## Remove line ending characters, and extra whitespace
    if re.search("^\[" + section + "\]", line):   ## If we're entering the right section
      while 1:
        line = file.readline()
        if len(line) == 0:                        ## Break this while loop if we're at the end of the file
          break
        line = line.strip()
        if re.search("^" + option + "=", line):
          (name, value) = re.split("=", line, 1)
          file.close
          return(str(value))

  ## Close the configuration file and return an error if we didn't find what we were looking for
  file.close()
  return(-1)

def drawShortcuts(widget):
  global shortcutPositon

  configFile = karamba.getThemePath(widget) + '/shortcuts.cfg'
  fp = file(configFile, 'r')
  lines = fp.readlines()
  fp.close

  numOfShortcuts = 0

  for entry in lines:
    if entry[:3] == 'EOF':
      break
    elif entry[0] != '#':
      expanded = string.split(entry, ',', 3)
      if expanded[2][-1] == '\n':
        expanded[2] = expanded[2][:-1]
      icon = getIcon(widget, expanded[0])
      if icon != -1:
        shortcutEntry = karamba.createImage(widget, (18*numOfShortcuts)+shortcutPosition, 9, icon)
        karamba.createClickArea(widget, (18*numOfShortcuts)+shortcutPosition, 9, 16, 16, expanded[1])
        karamba.addImageTooltip(widget, shortcutEntry, expanded[2])
      numOfShortcuts = numOfShortcuts + 1
  return numOfShortcuts


def createTask(widget, position, taskname, icon, taskpointer):
  global taskStartPosition
  global taskWidth

  button = karamba.createImage(widget, taskStartPosition + (taskWidth*position), 0, "pics/task.png")
  text = karamba.createText(widget, taskStartPosition + (taskWidth*position) +22, 9, 90, 20, taskname)
  karamba.changeTextColor(widget,text,255,255,255)
  karamba.changeTextSize(widget,text,8)
  retIcon = karamba.createImage(widget, taskStartPosition + (taskWidth*position)+4, 8, getIcon(widget, icon))
  task = taskpointer
  karamba.showImage(widget, button)
  karamba.showImage(widget,retIcon)
  retval = [button, text, retIcon, task]
  return retval


def clearTasks(widget, tasks):
  for task in tasks:
    karamba.deleteImage(widget, task[0])
    karamba.deleteText(widget, task[1])
    if task[2] != "":
      karamba.deleteImage(widget, task[2])
  del tasks
  return []

