##########################################
# osXBar 1.0 20030923 - 20031001 -20031015
# Source code GPL
# stefano@xiaprojects.com
# http://www.xiaproject.com
#
#

import karamba


import math

class osXBarMatrix:
	XMatrix=[]
	YMatrix=[]
	ZMatrix=[]
	DMatrix=[]
	KMatrix=[]
	SizeMatrix=0
	Engine=0
	def Init(self,NextStatus):
		if(NextStatus==0):
			# We have to reset all data
			self.XMatrix=[]
			self.YMatrix=[]
			self.ZMatrix=[]
			self.DMatrix=[]
			self.KMatrix=[]
			self.SizeMatrix=0
			pass

		if(NextStatus==1):
			# We have to create the Matrix
			# Default is tria
			self.Make(self.Engine.Configuration["Design"])
			pass
	def Make(self, Design):
		if(Design=="osx" or Design=="realosx"):
			# 20031017
			# Creating old style osx bar
			# 20031017
			if(Design=="realosx"):
				self.Engine.DesignXMoltiplier=1
				self.Engine.DesignYMoltiplier=1
				self.Engine.DesignDMoltiplier=3

			# Max & Min of mouse
			self.Engine.Configuration["mouseXMin"]=self.Engine.Configuration["borderLeft"]
			# How long the pointer will affect
			#self.SizeMatrix=self.Engine.Configuration["ImageSizeBig"]
			self.SizeMatrix= (self.Engine.Configuration["ImageSize"] + self.Engine.Configuration["iconSeparation"])*2
			#
			ratio=(self.Engine.Configuration["ImageSizeBig"]-self.Engine.Configuration["ImageSize"]+0.0)/(self.SizeMatrix*2)
			# We have to get the centerY
			x,y=self.MakeCenter(0)
			xx,yy=self.MakeSpace(0)
			#ratioy=(-float(y-self.Engine.Configuration["ImageSizeBig"]/2-yy+self.Engine.Configuration["ImageSize"]/2))/(self.SizeMatrix*2)
			ratioy=(-float(self.Engine.Configuration["iconRaise"])/float(self.SizeMatrix*2))
			ratiod=(float(self.Engine.Configuration["iconHoriz"])/float(self.SizeMatrix*2))
			# Makeup
			for mouseinx in range(self.SizeMatrix*2):
				self.ZMatrix.append( float(self.Engine.Configuration["ImageSizeBig"]-float(ratio*mouseinx)))
				self.YMatrix.append( float( self.ZMatrix[mouseinx]/2 + float(self.SizeMatrix*2-mouseinx)*ratioy-float(self.Engine.Configuration["ImageSize"]/2)))
				self.XMatrix.append( (float (self.ZMatrix[mouseinx]/2)-(self.Engine.Configuration["ImageSize"]/float(2))))
			# Now Make up the Horiz Shift
			for mouseinx in range(self.SizeMatrix*2):
				vett=[]
				for mouseiny in range(self.SizeMatrix*2):
					#if(mouseinx<self.ZMatrix[mouseinx/2+mouseiny/2]):
					##	# we are on the center of 2 icons...
					#	vett.append(ratiod*mouseinx)
					#else:
					#	vett.append(self.XMatrix[mouseinx/2+mouseiny/2])
					kappa=float(self.ZMatrix[mouseinx/2+mouseiny/2]*3)/float(self.Engine.Configuration["ImageSizeBig"])
					kappa=kappa*float(self.Engine.DesignDMoltiplier)
					vett.append((ratiod*mouseinx*kappa))
				self.DMatrix.append(vett)
				#print vett[0]
			#ratiok=float(self.Engine.Configuration["iconHoriz"]*2)/(self.SizeMatrix*2)
			#ratiok=(self.Engine.Configuration["iconHoriz"]*2)/(self.SizeMatrix*2)
			ratiok=float(self.DMatrix[self.SizeMatrix*2-1][0])/(self.SizeMatrix*2)

			for mouseinx in range(self.SizeMatrix*2):
				# xShiftLeft
				self.KMatrix.append(ratiok*float(self.SizeMatrix*2-mouseinx))
				#self.KMatrix.append(int(ratiok*self.Engine.DesignDMoltiplier*(self.SizeMatrix*2-mouseinx)))
				#print str(ratiok*float(self.SizeMatrix*2-mouseinx))
			for setotint in range(self.SizeMatrix*2):
				self.KMatrix[setotint]=int(self.KMatrix[setotint])
				self.ZMatrix[setotint]=int(self.ZMatrix[setotint])
				self.YMatrix[setotint]=int(self.YMatrix[setotint])
				self.XMatrix[setotint]=int(self.XMatrix[setotint])
				for setvettonint in range(self.SizeMatrix*2):
					self.DMatrix[setotint][setvettonint]=int(self.DMatrix[setotint][setvettonint])

		if(Design=="tria"):
			## Makeup the tria
			# Max & Min of mouse
			self.Engine.Configuration["mouseXMin"]=self.Engine.Configuration["borderLeft"]
			# How long the pointer will affect
			#self.SizeMatrix=self.Engine.Configuration["ImageSizeBig"]
			self.SizeMatrix=(self.Engine.Configuration["ImageSize"]+self.Engine.Configuration["iconSeparation"])*2
			#
			ratio=(self.Engine.Configuration["ImageSizeBig"]-self.Engine.Configuration["ImageSize"]+0.0)/(self.SizeMatrix*2)
			#radiod=(self.Engine.Configuration["iconHoriz"]+0.0)/(self.SizeMatrix*2)
			# We have to get the centerY
			x,y=self.MakeCenter(0)
			xx,yy=self.MakeSpace(0)
			#ratioy=(-float(y-self.Engine.Configuration["ImageSizeBig"]/2-yy+self.Engine.Configuration["ImageSize"]/2))/(self.SizeMatrix*2)
			ratioy=(-float(self.Engine.Configuration["iconRaise"])/(self.SizeMatrix*2))
			# Makeup
			for mouseinx in range(self.SizeMatrix*2):
				self.ZMatrix.append(int(self.Engine.Configuration["ImageSizeBig"]-(ratio*mouseinx)))
				self.YMatrix.append(int(self.ZMatrix[mouseinx]/2)+int((self.SizeMatrix*2-mouseinx)*ratioy)-(self.Engine.Configuration["ImageSize"]/2))
				self.XMatrix.append(int(self.ZMatrix[mouseinx]/2)-int(self.Engine.Configuration["ImageSize"]/2))

			# Now Make up the Horiz Shift
			for mouseinx in range(self.SizeMatrix*2):
				vett=[]
				for mouseiny in range(self.SizeMatrix*2):

					vett.append(int((abs(math.sin((mouseinx+0.0)*3.14/(self.SizeMatrix*2))))*self.Engine.Configuration["iconHoriz"]))
				self.DMatrix.append(vett)
			for mouseinx in range(self.SizeMatrix*2):
				# xShiftLeft
				self.KMatrix.append(0)
			pass
		pass
	def MakeSpace(self,index):
		# This will return the Alilgn of icons
		x= self.Engine.Configuration["borderLeft"] + (index*(self.Engine.Configuration["iconSeparation"]+self.Engine.Configuration["ImageSize"]))
		y= self.Engine.Configuration["borderTop"]
		return x,y
	def MakeCenter(self,index):
		# This will return the Alilgn of icons
		(x,y)=self.MakeSpace(index)
		x=x+(self.Engine.Configuration["ImageSize"]/2)
		y=y+(self.Engine.Configuration["ImageSize"]/2)+self.Engine.Configuration["iconRaise"]
		return x,y
	def MakeCenterWidget(self,align):
		# return the X,Y for the widget
		wx=(self.Engine.Configuration["DisplayX"]/2)-(self.Engine.Configuration["WidgetWidth"]/2)
		if(align=="top"):
			# To Cantor: Tanks for bug fix
			#wy=0+self.Engine.Configuration["ImageSize"]+self.Engine.Configuration["borderTop"]
			wy=0+self.Engine.Configuration["borderTop"]
		if(align=="bottom"):
			wy=self.Engine.Configuration["DisplayY"]-(self.Engine.Configuration["ImageSize"]+self.Engine.Configuration["borderTop"]+self.Engine.Configuration["borderBottom"])
		return wx,wy
	def MakeSpaceWidgetN(self,n):
		# How much the Widget is width
		# The icons
		wx=(self.Engine.Configuration["ImageSize"]+self.Engine.Configuration["iconSeparation"])*n
		# The borders
		wx=wx+self.Engine.Configuration["borderLeft"]*2
		# Desktop Selector
		#wx=wx+self.Engine.Pager.PagerdX
		#wx=wx+self.DMatrix[self.SizeMatrix*2-1][self.SizeMatrix*2-1]*self.Engine.DesignDMoltiplier*2
		#wx=wx+self.DMatrix[self.SizeMatrix*2-1][0]*self.Engine.DesignDMoltiplier*2
		# Other Stuff
		# Y
		wy=self.Engine.Configuration["ImageSize"]+self.Engine.Configuration["borderTop"]+self.Engine.Configuration["borderBottom"]
		return wx,wy

	def MakeSpaceMaxWidget(self):
		return self.MakeSpaceWidgetN(self.Engine.NumerOfStaticIcons+self.Engine.Configuration["MaxTaskIcons"])

	def MakeSpaceWidget(self):
		return self.MakeSpaceWidgetN(len(self.Engine.Objects))
	def MakeDynBarSpace(self,part,DiffIconY):
		# return xy, of the part
		if(part==0):
			# right side
			x=self.Engine.Objects[0].defaultX-(self.Engine.Configuration["ImageSize"]+16)-self.KMatrix[DiffIconY]
			y=self.Engine.Objects[0].defaultY-8
		if(part==1):
			# center
			x=self.Engine.Objects[0].defaultX-self.KMatrix[DiffIconY]
			y=self.Engine.Objects[0].defaultY-8
		if(part==2):
			# left side
			lasticonidx=len(self.Engine.Objects)-1
			x=self.Engine.Objects[lasticonidx].defaultX+self.Engine.Configuration["ImageSize"]+self.Engine.Configuration["iconSeparation"]+self.KMatrix[DiffIconY]
			y=self.Engine.Objects[0].defaultY-8
		return x,y

	def MakeBarSpace(self,part):
		# return xy, of the part
		if(part==0):
			# right side
			# 20031018
			#x=self.Engine.Objects[0].currentX-48
			# 20031124
			# tanks to muhulu
			x=self.Engine.Objects[0].currentX-(self.Engine.Configuration["ImageSize"]+16)
			#y=self.Engine.Objects[0].currentY-8
			y=self.Engine.Objects[0].defaultY-8
		if(part==1):
			# center
			# 20031018
			x=self.Engine.Objects[0].currentX
			#y=self.Engine.Objects[0].currentY-8
			y=self.Engine.Objects[0].defaultY-8
		if(part==2):
			# left side
			lasticonidx=len(self.Engine.Objects)-1
			# 20031018
			#x=self.Engine.Objects[lasticonidx].currentX+self.Engine.Configuration["ImageSize"]+self.Engine.Configuration["iconSeparation"]
			x=self.Engine.Objects[lasticonidx].currentX+self.Engine.Objects[lasticonidx].currentZ+self.Engine.Configuration["iconSeparation"]
			#y=self.Engine.Objects[0].currentY-8
			y=self.Engine.Objects[0].defaultY-8

		return x,y
