##########################################
# osXBar 1.0 20030923 - 20031001 -20031015
# Source code GPL
# stefano@xiaprojects.com
# http://www.xiaproject.com
#
#


import karamba
import os
import string
import time
import osXBarObject
import threading
import osXBarSupport
import thread

class osXBarTask:
	# A Small time to sleep :)
	# I'm sorry for this....
	# when calendar is showed osxbar use 100% of cpu.
	#SmallSleep=0.1
	Engine=0
	Matrix=0
	TaskListIgnore=[]
	# 20031108
	TaskListInfoName=[]
	TaskListInfoProc=[]
	TaskListQueue=[]
	LocalTaskProc=[]
	#TaskListLocked=0
	ThreadTask=0
	EventTaskLock=threading.Semaphore()
	#EventTask=threading.Semaphore()
	EventTask=threading.Event()

	def Init(self, NextStatus):
		if(NextStatus==0):
			# Reset
			print "TaskManager Init 0"
			#self.TaskListLocked=0
			#self.EventTaskLock.clear()
			#self.EventTask.clear()
			#self.EventTaskLock.set()
			#self.EventTaskLock.release()
			if(self.ThreadTask!=0):
				# We have to stop the thread
				thread.exit(self.ThreadTask)
				self.ThreadTask=0
		if(NextStatus==5):
			# Ready to enable Sensors
			self.ThreadTask=thread.start_new_thread(self.ThreadProc,())

	def ThreadProc(self):
		# Task Manager Loop
		while 1:
			time.sleep(self.Engine.Sensor.SleepTime)
			print "TaskMgr is working..."
			self.EventTask.wait()
			print "TaskMgr: Waiting for list"
			self.Engine.Sensor.EventReady.wait()
			print "TaskMgr: Waiting for list: Ready"
			self.Update_Passive()

	def TaskAdded(self,task):
		print "IRQ: Task Added"
		self.Update_TaskList()
	def TaskRemoved(self,task):
		print "IRQ: Task Removed"
		self.Update_TaskList()
	def TaskChanged(self,task):
		print "IRQ: Task Changed"
		return

	def Update_TaskList(self):
		# SPEEDY
		print "TaskManager List Update"
		# TODO: Semaphore
		#if(self.TaskListLocked!=0):
		#	return
		#if(self.EventTaskLock.isSet()==0):
		if(0):
			print "Mutex Error"
			osXBarSupport.osXBar_ErrorMessage("osXBarTask:53 Multithread Mutex isn't working, to POST this information to XIA Projects click YES, otherwise none will done. If this message popup again I suggest to POST data.","osXBarTask:53")
			return
		#self.EventTaskLock.set()
		#self.EventTaskLock.wait()
		self.EventTaskLock.acquire()
		print "TaskManager List Update OK"
		# TODO: Semaphore
		#self.TaskListLocked=1
		# Ok we can update with new task list
		TaskList = karamba.getTaskList(self.Engine.Widget)
		# Loading...
		self.TaskListInfoName=[]
		self.TaskListInfoProc=[]
		for task in TaskList:
			## getting task informations
			self.TaskListInfoName.append(karamba.getTaskInfo(self.Engine.Widget, task)[2])
			self.TaskListInfoProc.append(karamba.getTaskInfo(self.Engine.Widget, task)[0])

		#self.TaskListLocked=0
		self.EventTask.set()
		#self.EventTask.release()
		#self.EventTaskLock.set()
		self.EventTaskLock.release()

	# 20031108
	def Update(self):
		# SPEEDY
		print "TaskManager GUI Update"
		# TODO: Semaphore
		#self.EventTaskLock.wait()
		self.EventTaskLock.acquire()
		#if(self.TaskListLocked!=0):
		#	return
		# TODO: Semaphore
		#self.TaskListLocked=1
		for i in range(len(self.Engine.Objects)):
			## Arrows
			#print self.Engine.Objects[i].Command + " " +str(self.Engine.Objects[i].ShowArrow) + " " +str(self.Engine.Objects[i].ShowedArrow)
			if(self.Engine.Objects[i].ShowArrow!=self.Engine.Objects[i].ShowedArrow):
				if(self.Engine.Objects[i].ShowArrow==0):
					karamba.hideImage(self.Engine.Widget, self.Engine.Objects[i].imgArrow)
				else:
					karamba.showImage(self.Engine.Widget, self.Engine.Objects[i].imgArrow)
				self.Engine.Objects[i].ShowedArrow=self.Engine.Objects[i].ShowArrow
		for i in range(len(self.TaskListQueue)):
			# New tasks
			(nx,ny)=self.Matrix.MakeSpace(len(self.Engine.Objects))
			(px,py)=self.Matrix.MakeCenter(len(self.Engine.Objects))
			self.TaskListQueue[i].CreateVirtual(self.Engine,self.TaskListQueue[i].imgSource,self.TaskListQueue[i].Command,self.TaskListQueue[i].WindowTitle,self.TaskListQueue[i].TextString,nx,ny,self.Engine.Configuration["ImageSize"],px,py)

			self.TaskListQueue[i].AppendObject(self.TaskListQueue[i])
			self.TaskListQueue[i].CreateObject(self.Engine.Widget)
			self.Engine.ResizeWidget()
			self.TaskListQueue[i].ShowArrow=1
			self.TaskListQueue[i].ShowedArrow=1
			karamba.showImage(self.Engine.Widget, self.TaskListQueue[i].imgArrow)
			self.Engine.HasMoved=1
			self.Engine.MouseMoved(self.Engine.lastx,self.Engine.lasty,self.Engine.lastbutton)
			print "Task Succesfully added: ["+ self.TaskListQueue[i].Command +"] "+ self.TaskListQueue[i].WindowTitle

		# TODO: Semaphore
		self.TaskListQueue=[]
		self.LocalTaskProc=[]
		#self.TaskListLocked=0
		#self.EventTaskLock.set()
		self.EventTaskLock.release()
		# self.Update_Passive()
		#self.EventTask.set()
		return
	def Update_Thread2(self):
		# SLOW
		# this will be called every time we have to update
		# but it's called by sensor thread!!!

		#
		print "TaskMgr: Update Thread"
		#
		self.EventTaskLock.acquire()
		print "TaskMgr: Update Thread Lock"
		# check if there is data
		#if(len(self.TaskListInfoProc)<1 and self.EventTask.isSet()==0):
		if(self.EventTask.isSet()==0):
			# no list loaded, we ask for the list
			#self.EventTask.clear()
			print "TaskMgr: Query for list"
			self.Engine.Sensor.EventReady.wait()
			self.Engine.Sensor.RefreshIcons.append(-2)
			#self.Engine.Sensor.Ready=1
			print "TaskMgr: Query for list: Lock"
			#self.EventTask.wait()
			#self.EventTask.acquire()
			#self.EventTaskLock.acquire()
			print "TaskMgr: Query for list: Ready"
			#return
		# ok there is tasks..
		# scan them...
		self.Update_Passive()
	def Update_Thread(self):
		# SLOW
		# this will be called every time we have to update
		# but it's called by sensor thread!!!

		#
		print "TaskMgr: Update Thread"
		#
		self.EventTaskLock.acquire()
		print "TaskMgr: Update Thread Lock"
		# check if there is data
		#if(len(self.TaskListInfoProc)<1 and self.EventTask.isSet()==0):
		if(self.EventTask.isSet()==0):
			print "TaskMgr: Query for list"
			self.Engine.Sensor.EventReady.wait()
			self.Engine.Sensor.RefreshIcons.append(-2)
		self.EventTaskLock.release()

	def Update_Passive_Expire(self):
		print "Update Expire icons"
		self.EventTaskLock.acquire()
		print "Update Expire icons OK"
		for i in range(self.Engine.NumerOfStaticIcons,len(self.Engine.Objects)):
			#time.sleep(self.Engine.Sensor.SleepTime)
			#self.Engine.Objects[i].ShowArrow=0
			if(self.Engine.Objects[i].Locked==0 and self.Engine.Objects[i].ShowArrow==0):
				self.Engine.Objects[i].TimeToLive=self.Engine.Objects[i].TimeToLive+1
				print self.Engine.Objects[i].Command + " " + str(self.Engine.Objects[i].TimeToLive)
				if(self.Engine.Objects[i].TimeToLive > self.Engine.Configuration["MaxTaskLife"] * self.Engine.Objects[i].MaxTimeMoltiplier ):
					print "There will be icons to be removed"
					#self.Engine.Sensor.EventReady.wait()
					self.Engine.Sensor.RefreshIcons.append(-2)
					break

		self.EventTaskLock.release()

	def Update_Passive(self):
		# SLOW
		# self.Update_TaskList()
		print "Updating taskMgr"

		#if(self.TaskListLocked!=0):
		#	return
		# TODO: Semaphore
		#self.TaskListLocked=1
		#time.sleep(self.Engine.Sensor.SleepTime)
		#self.EventTaskLock.wait()
		self.EventTaskLock.acquire()
		TaskFound=0
		for i in range(len(self.Engine.Objects)):
			#time.sleep(self.Engine.Sensor.SleepTime)
			self.Engine.Objects[i].ShowArrow=0
			if(self.Engine.Objects[i].Locked==0):
				self.Engine.Objects[i].TimeToLive=self.Engine.Objects[i].TimeToLive+1
		## Selecting ony of all process
		#time.sleep(self.Engine.Sensor.SleepTime)
		for i in range(len(self.TaskListInfoProc)):
			## getting task informations
			time.sleep(self.Engine.Sensor.SleepTime)
			TaskName = self.TaskListInfoName[i]
			TaskProc = self.TaskListInfoProc[i]
			TaskProcs = TaskProc.split('-')
			#TaskProcs = TaskProc.split(' ')
			TaskProc = TaskProcs[len(TaskProcs)-1].strip()
			#print TaskProc
			TaskFound=-2
			# 20031024
			escluso=0
			for cerca in range(len(self.TaskListIgnore)):
				#time.sleep(self.Engine.Sensor.SleepTime)
				if(self.TaskListIgnore[cerca]==TaskProc):
					escluso=1
					break
				if(self.TaskListIgnore[cerca]==TaskName):
					escluso=1
					break
			# Loading and Checcking for the tast proc
			# only 1 icon for 1 proc
			#time.sleep(self.Engine.Sensor.SleepTime)
			if(escluso!=0):
				TaskFound=-1
				continue
			for i in range(len(self.LocalTaskProc)):
				#time.sleep(self.Engine.Sensor.SleepTime)
				if(self.LocalTaskProc[i]==TaskName):
					escluso=1
					break
			if(escluso!=0):
				TaskFound=-1
				continue

			# print "Searching icon for: " + TaskName + "["+TaskProc+"]"
			# print "1"
			#time.sleep(self.Engine.Sensor.SleepTime)
			# Controllo del comando da eseguire
			for i in range(len(self.Engine.Objects)):
				time.sleep(self.Engine.Sensor.SleepTime)
				if(TaskProc == self.Engine.Objects[i].Command or TaskProc == self.Engine.Objects[i].WindowTitle):
					## Task Found!
					TaskFound=i
					#print "Trovato ad 1"
					break
			# print "2"
			# Controllo Titolo finestra nel comando oppure titolo == titolo
			if(TaskFound<0):
				time.sleep(self.Engine.Sensor.SleepTime)
				for i in range(len(self.Engine.Objects)):
					# print TaskName  + "==" + self.Engine.Objects[i].Command
					time.sleep(self.Engine.Sensor.SleepTime)
					if TaskName ==  self.Engine.Objects[i].Command or TaskName == self.Engine.Objects[i].WindowTitle:
						TaskFound=i
						#print "Trovato ad 2"
						break
			# Controllo ricerca del comando nel titolo
			if(TaskFound<0):
				time.sleep(self.Engine.Sensor.SleepTime)
				for i in range(len(self.Engine.Objects)):
					time.sleep(self.Engine.Sensor.SleepTime)
					if string.find(TaskProc,self.Engine.Objects[i].WindowTitle)!=-1:
						TaskFound=i
						#print "Trovato ad 3"
						break
			# print "3"
			#time.sleep(self.Engine.Sensor.SleepTime)
			if(TaskFound>=0):
				# if(self.Engine.Objects[TaskFound].ShowArrow==0):
				self.Engine.Objects[TaskFound].ShowArrow=1
				## Setup the TimeToLive
				self.Engine.Objects[TaskFound].TimeToLive=0
				continue
			# Task not in list
			# print "4"
			#time.sleep(self.Engine.Sensor.SleepTime)
			if(TaskFound<0):
				## Check for the Maximun number of icons
				if(self.Engine.Configuration["MaxTaskIcons"]>((len(self.Engine.Objects))-self.Engine.NumerOfStaticIcons)):
					escluso=0
				if(escluso==0):
					time.sleep(self.Engine.Sensor.SleepTime)
					## We have to add the Icon
					NewObject=osXBarObject.osXBarObject()
					# Append to the Active Queue
					#NewObject.AppendObject(NewObject)
					#NewObject.CreateObject(self.Engine.Widget)
					NewObject.CreateVirtual(self.Engine,TaskName,TaskName,TaskProc,TaskProc,-1000,0,0,0,0)
					#NewObject.ShowArrow=1
					self.TaskListQueue.append(NewObject)
					self.LocalTaskProc.append(TaskName)
					print "This task is in queue:"  + TaskName

				else:
					print "Task Escluso " + TaskName
		# Loading...
		self.TaskListInfoName=[]
		self.TaskListInfoProc=[]
		time.sleep(self.Engine.Sensor.SleepTime)
		UpdateGUI=0
		for i in range(len(self.Engine.Objects)):
			# che the real call to update the gui if need
			time.sleep(self.Engine.Sensor.SleepTime)
			if(self.Engine.Objects[i].ShowedArrow!=self.Engine.Objects[i].ShowArrow):
				UpdateGUI=1
				break
		# TODO: Semaphore
		## Removing the Added Tasks
		time.sleep(self.Engine.Sensor.SleepTime)
		for i in range(len(self.Engine.Objects)):
			## After 15 seconds?
			#print self.Engine.Objects[i].Command + " " +str(self.Engine.Objects[i].TimeToLive)
			#time.sleep(self.Engine.Sensor.SleepTime)
			#print self.Engine.Objects[i].Command + " " + str(self.Engine.Objects[i].TimeToLive) + "/"+str(self.Engine.Configuration["MaxTaskLife"]*self.Engine.Objects[i].MaxTimeMoltiplier)
			if(self.Engine.Objects[i].TimeToLive>self.Engine.Configuration["MaxTaskLife"]*self.Engine.Objects[i].MaxTimeMoltiplier):
				## Reset Counter
				#self.Engine.Objects[i].TimeToLive=0
				## if it's a added icon, we remove it
				if(i>=self.Engine.NumerOfStaticIcons):
					print "There will be icons to be removed"
					self.Engine.Sensor.EventReady.wait()
					self.Engine.Sensor.RefreshIcons.append(-4)
					#self.Engine.Sensor.Ready=1
					break
		time.sleep(self.Engine.Sensor.SleepTime)
		#self.TaskListLocked=0
		#self.EventTaskLock.set()
		if(UpdateGUI!=0 or len(self.TaskListQueue)):
			# ok update
			self.Engine.Sensor.EventReady.wait()
			self.Engine.Sensor.RefreshIcons.append(-1)
			#self.Engine.Sensor.Ready=1
		#time.sleep(self.Engine.Sensor.SleepTime)
		self.EventTask.clear()
		self.EventTaskLock.release()




	def Update_Remove(self):
		print "TaskManager REMOVING"
		# TODO: Semaphore
		#if(self.TaskListLocked!=0):
		#	return
		# TODO: Semaphore
		#self.TaskListLocked=1
		#self.EventTaskLock.wait()
		self.EventTaskLock.acquire()
		## Removing the Added Tasks
		for i in range(len(self.Engine.Objects)):
			## After 15 seconds?
			if(self.Engine.Objects[i].TimeToLive>self.Engine.Configuration["MaxTaskLife"]*self.Engine.Objects[i].MaxTimeMoltiplier):
				## Reset Counter
				self.Engine.Objects[i].TimeToLive=0
				## if it's a added icon, we remove it
				if(i>=self.Engine.NumerOfStaticIcons):
					self.Engine.Objects[i].Remove(self.Engine.Widget,i)
					# Redraw the Widget
					# Now Setup the width
					self.Engine.ResizeWidget()
					# Now redraw the widget
					# Invalidate the View
					self.Engine.HasMoved=1
					self.Engine.MouseMoved(self.Engine.lastx,self.Engine.lasty,self.Engine.lastbutton)
					break

		# TODO: Semaphore
		#self.TaskListLocked=0
		#self.EventTaskLock.set()
		self.EventTaskLock.release()
