###############################################################
#  Copyright by Charles Wienken
#  Licensed Under GPL
###############################################################

###############################################################
#  This import statement allows access to the karamba functions
###############################################################
import karamba
import string
import sys

#xBar Yes!
import xBar
from xBar import xBarcore

# Global xBar
xBar = 0

###############################################################
#  This is called when you widget is initialized
###############################################################
def initWidget( widget ):
        global xBar    

	imgPath = "xImages/" # path to the images
	themeName = "xTaskBar" # name of the theme
	height = 32 # height of widget
	
	# load the xBar with the widget, height, imgPath, and themeName
	xBar = xBarcore(widget,height,imgPath,themeName)
	    
###############################################################
#  This is called everytime your widget is updated
#  NOTE: The update inverval is specified in the .theme file
###############################################################
def widgetUpdated(widget):
        global xBar      

	xBar.update()

# called to indicate that a new task is currently started
def startupAdded(widget, startup):
	# add the tasks
	pass

# called whenever a startup is removed. Which either means the task is
# successfully started (and taskAdded will be called), or the task could
# not be started for some reason.
def startupRemoved(widget, startup):
	# add the tasks
	pass

# called whenever a new task has been started
def taskAdded(widget, task):
        global xBar      
	# add the tasks
	xBar.taskAdded()

# called whenever a task is removed
def taskRemoved(widget, task):
        global xBar      
	
	# remove the tasks
	xBar.taskRemoved()

# called whenever a new task has gained focus.
# task = the active task
def activeTaskChanged(widget, task):    
        global xBar  
    
        # activate the tasks
	xBar.activeTaskChanged()

    
# called whenever a new sys tray item has been added
def systemTrayWindowAdded(widget, window ):
    print 'systray Window Added'
    
def updateTrayWindows(widget):
    print 'update Tray Windows'
    
def layoutSystray(widget):
    print 'layout systray'

###############################################################
#  This is called when an option is selected
###############################################################
def menuOptionChanged( widget, key, value, init=0 ):
        global xBar
    
        xBar.menuConfigOptions( key, init )
    
###############################################################
#  This gets called everytime our widget is clicked.
#  NOTE:
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button clicked:
#  1 = Left Mouse Button
#  2 = Middle Mouse Button
#  3 = Right Mouse Button, but this will never happen
#      because the right mouse button brings up the
#      Karamba menu.
#  4,5 = Scroll wheel up and down
###############################################################
def widgetClicked(widget, x, y, button):
	global xBar
	
        xBar.barClicked(x, y, button)

###############################################################
#  This gets called everytime our widget is clicked.
#  NOTE:
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button being held:
#  0 = No Mouse Button
#  1 = Left Mouse Button
#  2 = Middle Mouse Button
#  3 = Right Mouse Button, but this will never happen
#      because the right mouse button brings up the
#      Karamba menu.
###############################################################
def widgetMouseMoved(x, y, button):
	###########################################################
	#  WARNING:  Don't do anything too intensive here
	#  You don't want to run some complex piece of code 
	#  everytime the mouse moves
	###########################################################
	pass

#This gets called when an item is clicked in a popup menu you have created.
#  menu = a reference to the menu
#  id = the number of the item that was clicked.
def menuItemClicked(widget, menu, id):
	global xBar 
	
        xBar.menuItemClicked(menu, id)
    

    
